#!/bin/sh


TAGS_ARG=bsp


###########
# help
###########
git_upgrade_help() {

	echo " *********************************** "
	echo " e.g.  git_upgrade /home/gitPatches  "
	echo " arg 1 is git path location          "
	echo " *********************************** "
}





###########
# Display All commit from $1 version to the current version
###########
GetCommits () {

   # Select origin version (origin TAG)
   echo " ** List all tags applied ** "
   git tag -l $TAGS_ARG*
   read ORIGIN_VERSION
   echo " origin version $ORIGIN_VERSION"

   # Get current SHA1
   CUR_SHA1=`git-show --pretty=format:"%H"`
   echo " current version $CUR_SHA1 "

   echo " ** Display Commit from $1 to the current version $2 ** "
   rm -rf commit.txt
   git-rev-list $ORIGIN_VERSION..$CUR_SHA1 --pretty=oneline > ./commit.txt
   cat ./commit.txt
}

GetCommits
